Package com.google.android.exoplayer2.trackselection

## Interface ExoTrackSelection

- All Superinterfaces:
    `TrackSelection`
  All Known Implementing Classes:
    `AdaptiveTrackSelection`, `BaseTrackSelection`, `FakeTrackSelection`, `FixedTrackSelection`, `RandomTrackSelection`

      public interface ExoTrackSelection
      extends TrackSelection

  A `TrackSelection` that can change the individually selected track as a result of calling `updateSelectedTrack(long, long, long, List, MediaChunkIterator[])` or `evaluateQueueSize(long, List)`. This only happens between calls to `enable()` and `disable()`.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `ExoTrackSelection.Definition` | Contains of a subset of selected tracks belonging to a `TrackGroup`.
    `static interface` | `ExoTrackSelection.Factory` | Factory for `ExoTrackSelection` instances.

  - ### Field Summary

    - ### Fields inherited from interface com.google.android.exoplayer2.trackselection.TrackSelection

      `TYPE_CUSTOM_BASE, TYPE_UNSET`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `blacklist​(int index, long exclusionDurationMs)` | Attempts to exclude the track at the specified index in the selection, making it ineligible for selection by calls to `updateSelectedTrack(long, long, long, List, MediaChunkIterator[])` for the specified period of time.
    `void` | `disable()` | Disables this track selection.
    `void` | `enable()` | Enables the track selection.
    `int` | `evaluateQueueSize​(long playbackPositionUs, List<? extends MediaChunk> queue)` | Returns the number of chunks that should be retained in the queue.
    `Format` | `getSelectedFormat()` | Returns the `Format` of the individual selected track.
    `int` | `getSelectedIndex()` | Returns the index of the selected track.
    `int` | `getSelectedIndexInTrackGroup()` | Returns the index in the track group of the individual selected track.
    `Object` | `getSelectionData()` | Returns optional data associated with the current track selection.
    `int` | `getSelectionReason()` | Returns the reason for the current track selection.
    `boolean` | `isBlacklisted​(int index, long nowMs)` | Returns whether the track at the specified index in the selection is excluded.
    `default void` | `onDiscontinuity()` | Called to notify the selection of a position discontinuity.
    `void` | `onPlaybackSpeed​(float playbackSpeed)` | Called to notify the selection of the current playback speed.
    `default void` | `onPlayWhenReadyChanged​(boolean playWhenReady)` | Called to notify when the playback is paused or resumed.
    `default void` | `onRebuffer()` | Called to notify when a rebuffer occurred.
    `default boolean` | `shouldCancelChunkLoad​(long playbackPositionUs, Chunk loadingChunk, List<? extends MediaChunk> queue)` | Returns whether an ongoing load of a chunk should be canceled.
    `void` | `updateSelectedTrack​(long playbackPositionUs, long bufferedDurationUs, long availableDurationUs, List<? extends MediaChunk> queue, MediaChunkIterator[] mediaChunkIterators)` | Updates the selected track for sources that load media in discrete `MediaChunk`s.

    - ### Methods inherited from interface com.google.android.exoplayer2.trackselection.TrackSelection

      `getFormat, getIndexInTrackGroup, getTrackGroup, getType, indexOf, indexOf, length`

- - ### Method Detail

    - #### enable

          void enable()

      Enables the track selection. Dynamic changes via `updateSelectedTrack(long, long, long, List, MediaChunkIterator[])`, `evaluateQueueSize(long, List)` or `shouldCancelChunkLoad(long, Chunk, List)` will only happen after this call.

      This method may not be called when the track selection is already enabled.

    - #### disable

          void disable()

      Disables this track selection. No further dynamic changes via `updateSelectedTrack(long, long, long, List, MediaChunkIterator[])`, `evaluateQueueSize(long, List)` or `shouldCancelChunkLoad(long, Chunk, List)` will happen after this call.

      This method may only be called when the track selection is already enabled.

    - #### getSelectedFormat

          Format getSelectedFormat()

      Returns the `Format` of the individual selected track.

    - #### getSelectedIndexInTrackGroup

          int getSelectedIndexInTrackGroup()

      Returns the index in the track group of the individual selected track.

    - #### getSelectedIndex

          int getSelectedIndex()

      Returns the index of the selected track.

    - #### getSelectionReason

          int getSelectionReason()

      Returns the reason for the current track selection.

    - #### getSelectionData

          @Nullable
          Object getSelectionData()

      Returns optional data associated with the current track selection.

    - #### onPlaybackSpeed

          void onPlaybackSpeed​(float playbackSpeed)

      Called to notify the selection of the current playback speed. The playback speed may affect adaptive track selection.
      Parameters:
        `playbackSpeed` - The factor by which playback is sped up.

    - #### onDiscontinuity

          default void onDiscontinuity()

      Called to notify the selection of a position discontinuity.

      This happens when the playback position jumps, e.g., as a result of a seek being performed.

    - #### onRebuffer

          default void onRebuffer()

      Called to notify when a rebuffer occurred.

      A rebuffer is defined to be caused by buffer depletion rather than a user action. Hence this method is not called during initial buffering or when buffering as a result of a seek operation.

    - #### onPlayWhenReadyChanged

          default void onPlayWhenReadyChanged​(boolean playWhenReady)

      Called to notify when the playback is paused or resumed.
      Parameters:
        `playWhenReady` - Whether playback will proceed when ready.

    - #### updateSelectedTrack

          void updateSelectedTrack​(long playbackPositionUs,
                                   long bufferedDurationUs,
                                   long availableDurationUs,
                                   List<? extends MediaChunk> queue,
                                   MediaChunkIterator[] mediaChunkIterators)

      Updates the selected track for sources that load media in discrete `MediaChunk`s.

      This method will only be called when the selection is enabled.

      Parameters:
        `playbackPositionUs` - The current playback position in microseconds. If playback of the period to which this track selection belongs has not yet started, the value will be the starting position in the period minus the duration of any media in previous periods still to be played.
        `bufferedDurationUs` - The duration of media currently buffered from the current playback position, in microseconds. Note that the next load position can be calculated as `(playbackPositionUs + bufferedDurationUs)`.
        `availableDurationUs` - The duration of media available for buffering from the current playback position, in microseconds, or `C.TIME_UNSET` if media can be buffered to the end of the current period. Note that if not set to `C.TIME_UNSET`, the position up to which media is available for buffering can be calculated as `(playbackPositionUs + availableDurationUs)`.
        `queue` - The queue of already buffered `MediaChunk`s. Must not be modified.
        `mediaChunkIterators` - An array of `MediaChunkIterator`s providing information about the sequence of upcoming media chunks for each track in the selection. All iterators start from the media chunk which will be loaded next if the respective track is selected. Note that this information may not be available for all tracks, and so some iterators may be empty.

    - #### evaluateQueueSize

          int evaluateQueueSize​(long playbackPositionUs,
                                List<? extends MediaChunk> queue)

      Returns the number of chunks that should be retained in the queue.

      May be called by sources that load media in discrete `MediaChunks` and support discarding of buffered chunks.

      To avoid excessive re-buffering, implementations should normally return the size of the queue. An example of a case where a smaller value may be returned is if network conditions have improved dramatically, allowing chunks to be discarded and re-buffered in a track of significantly higher quality. Discarding chunks may allow faster switching to a higher quality track in this case.

      Note that even if the source supports discarding of buffered chunks, the actual number of discarded chunks is not guaranteed. The source will call `updateSelectedTrack(long, long, long, List, MediaChunkIterator[])` with the updated queue of chunks before loading a new chunk to allow switching to another quality.

      This method will only be called when the selection is enabled and none of the `MediaChunks` in the queue are currently loading.

      Parameters:
        `playbackPositionUs` - The current playback position in microseconds. If playback of the period to which this track selection belongs has not yet started, the value will be the starting position in the period minus the duration of any media in previous periods still to be played.
        `queue` - The queue of buffered `MediaChunks`. Must not be modified.
      Returns:
        The number of chunks to retain in the queue.

    - #### shouldCancelChunkLoad

          default boolean shouldCancelChunkLoad​(long playbackPositionUs,
                                                Chunk loadingChunk,
                                                List<? extends MediaChunk> queue)

      Returns whether an ongoing load of a chunk should be canceled.

      May be called by sources that load media in discrete `MediaChunks` and support canceling the ongoing chunk load. The ongoing chunk load is either the last `MediaChunk` in the queue or another type of `Chunk`, for example, if the source loads initialization or encryption data.

      To avoid excessive re-buffering, implementations should normally return `false`. An example where `true` might be returned is if a load of a high quality chunk gets stuck and canceling this load in favor of a lower quality alternative may avoid a rebuffer.

      The source will call `evaluateQueueSize(long, List)` after the cancelation finishes to allow discarding of chunks, and `updateSelectedTrack(long, long, long, List, MediaChunkIterator[])` before loading a new chunk to allow switching to another quality.

      This method will only be called when the selection is enabled.

      Parameters:
        `playbackPositionUs` - The current playback position in microseconds. If playback of the period to which this track selection belongs has not yet started, the value will be the starting position in the period minus the duration of any media in previous periods still to be played.
        `loadingChunk` - The currently loading `Chunk` that will be canceled if this method returns `true`.
        `queue` - The queue of buffered `MediaChunks`, including the `loadingChunk` if it's a `MediaChunk`. Must not be modified.
      Returns:
        Whether the ongoing load of `loadingChunk` should be canceled.

    - #### blacklist

          boolean blacklist​(int index,
                            long exclusionDurationMs)

      Attempts to exclude the track at the specified index in the selection, making it ineligible for selection by calls to `updateSelectedTrack(long, long, long, List, MediaChunkIterator[])` for the specified period of time.

      Exclusion will fail if all other tracks are currently excluded. If excluding the currently selected track, note that it will remain selected until the next call to `updateSelectedTrack(long, long, long, List, MediaChunkIterator[])`.

      This method will only be called when the selection is enabled.

      Parameters:
        `index` - The index of the track in the selection.
        `exclusionDurationMs` - The duration of time for which the track should be excluded, in milliseconds.
      Returns:
        Whether exclusion was successful.

    - #### isBlacklisted

          boolean isBlacklisted​(int index,
                                long nowMs)

      Returns whether the track at the specified index in the selection is excluded.
      Parameters:
        `index` - The index of the track in the selection.
        `nowMs` - The current time in the timebase of `SystemClock.elapsedRealtime()`.